EDIT - feature request #5969
feature request # 3958 (Closed): Handle CDMPreference table

Implement CdmPreference reading for database preferences
07/08/2016 02:37 PM - Andreas Mller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.3

Severity: normal

Description

Start with NomenclaturalCode. The values are available through IPreferenceService.

See also #3958, #5971

Related issues:

Related to EDIT - feature request #5971: Implement database wide CdmPreferenc... Closed
Related to EDIT - bug #3658: Update Nomenclatural code for datasources Closed
Related to EDIT - feature request #5970: Implement allowOverride in CdmPrefer... Closed
Related to EDIT - bug #6215: NPE when opening preferences with no DB connection Closed
Precedes EDIT - bug #6105: Make CdmPreferences editable in separate view Closed
Precedes EDIT - bug #6106: [Discuss] Handle rights and roles for CdmPreferences Closed

Associated revisions

Revision 9252208 - 09/13/2016 11:48 AM - Katja Luther

ref #5969: add PreferenceService to applicationController

Revision b9801dc0 - 09/13/2016 11:57 AM - Katja Luther

ref #5969: get the preference NC from db when initialize preference store and save the changes in db

Revision 4625a011 - 09/15/2016 01:18 PM - Katja Luther

ref #5969: check if there is a NC preference in db if not use the local NC preference

Revision 2a7c9630 - 10/04/2016 12:11 PM - Katja Luther

ref #5969: check for db connection before ty to read the preferred nomenclatural code

Revision 68f310fd - 10/04/2016 12:19 PM - Katja Luther

ref #5969: add remark that the nomenclatural code preference is stored in db

Revision 1990fe50 - 10/07/2016 10:23 AM - Katja Luther

ref #5969: add PreferenceService to applicationController

History

#1 - 09/13/2016 01:48 PM - Katja Luther

- Description updated

- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

- % Done changed from 0 to 50

first implementation added.

#2 - 09/15/2016 11:50 AM - Andreas Miiller

- Status changed from Resolved to Feedback

03/20/2024
https://dev.e-taxonomy.eu/redmine/issues/3958
https://dev.e-taxonomy.eu/redmine/issues/5971

- Assignee changed from Andreas Miiller to Katja Luther

When trying to open Preferences-Taxonomic-NomenclaturalCode | got an NPE:

login

editor version

server

schema version

admin

4.

3.0.201609141050

test.e-taxonomy.eu / edit-test

4.

0.0.0.201604200000

os : Windows Server 2012 6.2 amd64

java

1.7.

0_65

java.lang.NullPointerException
at eu.etaxonomy.taxeditor.preference.PreferencesUtil.setPreferredNomenclaturalCode (PreferencesUtil. java:1ll
eu.etaxonomy.taxeditor.preference.NomenclaturalCodePreferences.init (NomenclaturalCodePreferences. java:8
ui.internal.dialogs.WorkbenchPreferenceNode.createPage (WorkbenchPreferenceNode. java:57)
jface.preference.PreferenceDialog.createPage (PreferenceDialog. java:1339)
ui.internal.dialogs.FilteredPreferenceDialog.createPage (FilteredPreferenceDialog. java:376)
jface.preference.PreferenceDialog.showPage (PreferenceDialog. java:1230)
ui.internal.dialogs.FilteredPreferenceDialog.showPage (FilteredPreferenceDialog. java:674)
jface.preference.PreferenceDialog$l0.run (PreferenceDialog. java:708)
swt.custom.BusyIndicator.showWhile (BusyIndicator.java:70)
jface.preference.PreferenceDialog$9.selectionChanged (PreferenceDialog. java:704)
jface.viewers.StructuredViewer$3.run (StructuredViewer. java:888)
core.runtime.SafeRunner.run (SafeRunner. java:42)
ui.internal.JFaceUtil$1l.run (JFaceUtil. java:49)

jface.util.SafeRunnable.run (SafeRunnable. java:175)
jface.viewers.StructuredViewer.firePostSelectionChanged (StructuredViewer. java:886)
jface.viewers.StructuredViewer.handlePostSelect (StructuredViewer. java:1226)
jface.viewers.StructuredViewer$5.widgetSelected (StructuredvViewer. java:1251)
jface.util.OpenStrategy.firePostSelectionEvent (OpenStrategy.java:262)
jface.util.OpenStrategy.access$5 (OpenStrategy. java:256)

jface.util.OpenStrategy$3.run (OpenStrategy.java:433)

swt.widgets.RunnableLock.run (RunnableLock. java:35)
swt.widgets.Synchronizer.runAsyncMessages (Synchronizer. java:135)
swt.widgets.Display.runAsyncMessages (Display.java:4140)
swt.widgets.Display.readAndDispatch (Display.java:3757)
jface.window.Window.runEventLoop (Window. java:825)
jface.window.Window.open (Window. java:801)
ui.internal.dialogs.WorkbenchPreferenceDialog.open (WorkbenchPreferenceDialog. java:215)
ui.internal.handlers.ShowPreferencePageHandler.execute (ShowPreferencePageHandler. java:54)
ui.internal.handlers.HandlerProxy.execute (HandlerProxy.java:293)
core.commands.Command.executeWithChecks (Command. java:476)
core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:508)
ui.internal.handlers.HandlerService.executeCommand (HandlerService. java:169)
ui.internal.handlers.SlaveHandlerService.executeCommand (SlaveHandlerService. java:241)
ui.menus.CommandContributionItem.handleWidgetSelection (CommandContributionItem. java:829)
ui.menus.CommandContributionItem.access$19 (CommandContributionItem. java:815)
ui.menus.CommandContributionItem$5.handleEvent (CommandContributionItem. java:805)
swt.widgets.EventTable.sendEvent (EventTable. java:84)

swt.widgets.Widget.sendEvent (Widget.java:1053)

swt.widgets.Display.runDeferredEvents (Display.java:4165)
swt.widgets.Display.readAndDispatch (Display.java:3754)
ui.internal.Workbench.runEventLoop (Workbench. java:2701)
ui.internal.Workbench.runUI (Workbench. java:2665)

ui.internal .Workbench.access$4 (Workbench. java:2499)
ui.internal.Workbench$7.run (Workbench. java:679)
core.databinding.observable.Realm.runWithDefault (Realm. java:332)
ui.internal.Workbench.createAndRunWorkbench (Workbench. java:668)
ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:149)

eu.etaxonomy.taxeditor.Application.start (Application. java:24)
.NativeMethodAccessorImpl.invokeO (Native Method)
equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle. java:196)
core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher.java:110

core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:79)
core.runtime.adaptor.EclipseStarter.run(EclipseStarter. java:344)
core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)

NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:57)
DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

java.lang.reflect.Method.invoke (Method. java:606)
org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:622)

org.eclipse.equinox.launcher.Main.basicRun (Main. java:577)
at org.eclipse.equinox.launcher.Main.run (Main.java:1410)

#3 - 09/15/2016 01:20 PM - Katja Luther

there was no check whether the preference is already in DB, now if the preference could not find in DB the local one is used.

#4 - 09/15/2016 01:20 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

#5 - 09/21/2016 10:19 AM - Andreas Miiller
- Related to feature request #3958: Handle CDMPreference table added

#6 - 09/21/2016 10:19 AM - Andreas Miiller

- Related to feature request #5971: Implement database wide CdmPreference writing added

#7 - 09/21/2016 11:57 AM - Andreas Miiller

- Precedes bug #6105: Make CdmPreferences editable in separate view added

#8 - 09/21/2016 12:05 PM - Andreas Miiller

The implementation in the local preferences Ul works well now and | think we can close the ticket.

But maybe we can leave a remark in the Ul that this value is stored in the database, not in the local preferences, to warn users.
Implementation in a separate Ul is handled in a follow up ticket: #6105

Another issue is rights management which is handled by #6106

#9 - 09/21/2016 12:05 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther

#10 - 09/21/2016 12:06 PM - Andreas Miiller
- Precedes bug #6106: [Discuss] Handle rights and roles for CdmPreferences added

#11 - 09/21/2016 01:03 PM - Andreas Miiller

If no datasource is selected an NPE occurs:

login
editor version : 4.3.0.201609201350
server : /

schema version

os : Windows Server 2012 6.2 amd64
java : 1.7.0_65
java.lang.NullPointerException

at eu.etaxonomy.taxeditor.preference.PreferencesUtil.setPreferredNomenclaturalCode (PreferencesUtil. java:1l1l

8)

at eu.etaxonomy.taxeditor.preference.NomenclaturalCodePreferences.init (NomenclaturalCodePreferences. java:8

6)

at org.eclipse.ui.internal.dialogs.WorkbenchPreferenceNode.createPage (WorkbenchPreferenceNode. java:57)

at org.eclipse. jface.preference.PreferenceDialog.createPage (PreferenceDialog. java:1339)

at org.eclipse.ui.internal.dialogs.FilteredPreferenceDialog.createPage (FilteredPreferenceDialog. java:376)

at org.eclipse.jface.preference.PreferenceDialog.showPage (PreferenceDialog. java:1230)

at org.eclipse.ui.internal.dialogs.FilteredPreferenceDialog.showPage (FilteredPreferenceDialog. java:674)

at org.eclipse.jface.preference.PreferenceDialog$10.run (PreferenceDialog. java:708)
at org.eclipse.swt.custom.BusyIndicator.showWhile (BusyIndicator. java:70)

at org.eclipse.jface.preference.PreferenceDialog$9.selectionChanged (PreferenceDialog. java:704)

at org.eclipse.jface.viewers.StructuredViewer$3.run (StructuredViewer. java:888)
at org.eclipse.core.runtime.SafeRunner.run (SafeRunner. java:42)

This is kind of important because it is currently the only possibility to set the local preference (in case a database preference is not yet set)

#12 - 09/26/2016 02:38 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

In Revision 4625a011 a check for the existence of the preference in DB is added.
https://dev.e-taxonomy.eu/redmine/issues/6105
https://dev.e-taxonomy.eu/redmine/issues/6106

#13 - 10/04/2016 11:28 AM - Andreas Miiller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther
- % Done changed from 50 to 80

Katja Luther wrote:

In Revision 4625a011 a check for the existence of the preference in DB is added.

This does not seem to fix the problem. | checked with the latest nightly (Sep. 30th)

Please also add the remark on the Ul as mentioned in #note-8 before closing the ticket fully.

#14 - 10/04/2016 12:21 PM - Katja Luther

| added a remark that that the preference is stored in db and a check whether the editor is already connected to a datasource.

#15 - 10/06/2016 09:30 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

#16 - 10/13/2016 11:49 AM - Andreas Miiller
- Related to bug #3658: Update Nomenclatural code for datasources added

#17 - 11/15/2016 02:53 PM - Andreas Miiller

- Related to feature request #5970: Implement allowOverride in CdmPreference added

#18 - 11/23/2016 02:27 PM - Andreas Miiller
- Status changed from Feedback to Closed

I think we can close this ticket now. Open issues will be checked in #5971 and are more related to writing then reading

#19 - 11/23/2016 02:27 PM - Andreas Miiller
- Assignee changed from Andreas Muiller to Katja Luther

- % Done changed from 80 to 100

#20 - 11/23/2016 02:39 PM - Andreas Miiller
- Related to bug #6215: NPE when opening preferences with no DB connection added

#21 - 11/23/2016 03:01 PM - Andreas Miiller
- Parent task set to #3958

#22 - 09/13/2017 02:24 PM - Andreas Miiller

- Private changed from Yes to No
https://dev.e-taxonomy.eu/redmine/issues/5971
